
;;; copy-downloads.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: copy-downloads.el
;; Author/Maintainer: Davin Max Pearson <http://davin.50webs.com>
;; Keywords: Unix Backup
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code

(require 'd-directory-files-deep)

(defun copy-files-across ()
  (interactive)
  (setq c-downloads "/media/www/WD2TB-BLU/albums/internal/")
  (setq f-downloads "/media/www/WD2TB-RED/albums/internal/")
  (let (ptr list len count)
    (setq list (d-directory-files-deep c-downloads))
    (setq ptr list)
    (setq len (length list))
    (setq count 0)
    (while ptr
      (make-directory (file-name-directory (concat f-downloads (car ptr))) 'PARENTS)
      (condition-case err
          (when (and (file-exists-p (concat c-downloads (car ptr)))
                     (not (file-exists-p (concat f-downloads (car ptr)))))
            (when (not (or (file-symlink-p f-downloads)
                           (file-symlink-p (concat f-downloads (car ptr)))))
              (message "------------------------------------------------")
              (message "Copying file %s progress=%s%%" (car ptr) (/ (* 100 count) len))
              (copy-file (concat c-downloads "/" (car ptr))
                         (concat f-downloads "/" (car ptr))
                         nil
                         'KEEP-TIME)))
        (error (message "Error %s" (prin1-to-string err))))
      (incf count)
      (setq ptr (cdr ptr)))
  (d-quote
   let (ptr list len count)
   (setq list (d-directory-files-deep f-downloads))
   (setq ptr list)
   (setq len (length list))
   (setq count 0)
   (while ptr
     (if (and (file-exists-p (concat c-downloads (car ptr)))
              (not (file-symlink-p (concat c-downloads)))
              (not (file-symlink-p (concat c-downloads (car ptr)))))
         (condition-case err
             (progn
               (message "------------------------------------------------")
               (message "Copying file %s progress=%s%%" (car ptr) (/ (* 100 count) len))
               (copy-file (concat f-downloads (car ptr))
                          (concat c-downloads (car ptr))
                          nil
                          'KEEP-TIME))
           (error nil)))
     (incf count)
     (setq ptr (cdr ptr))) ;; END WHILE! ptr
   )))

(provide 'copy-files-across)
