
;;; d-debugger.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-debugger.el
;; Author/Maintainer: Davin Max Pearson <http://davin.50webs.com>
;; Keywords: debugger functionality
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:

(defun d-debugger-mode-hook ()
  (setq truncate-lines nil))

(add-hook 'debugger-mode-hook 'd-debugger-mode-hook)

;; (save-some-buffers (setq arg 'NO-QUESTIONS))
(d-quote
 defadvice save-some-buffers (around d-save-some-buffers activate)
 (let* ((list (buffer-list))
        (ptr  list)
        (s    nil))
   ;; (setq ptr (buffer-list))
   ;; (setq ptr (cdr ptr))
   (save-excursion
     (while ptr
       (when (and (not (string-match "^\\*" (buffer-name (car ptr))))
                  (not (string-match "^ " (buffer-name (car ptr))))
                  (save-excursion
                    (set-buffer (car ptr))
                    (not (eq major-mode 'dired-mode))))
         (if (not arg)
             (when (and (buffer-modified-p (car ptr))
                        (y-or-n-p (format "Really save this buffer?\n%s"
                                          (buffer-name (car ptr)))))
               (progn
                 ;;(message "Saving file\n%s" (buffer-file-name (car ptr)))
                 (setq s t)
                 (save-buffer (car ptr))
                 (save-excursion
                   (set-buffer (car ptr))
                   (set-buffer-modified-p nil))))
           (save-buffer (car ptr))))
       (setq ptr (cdr ptr)))
     (when (not s)
       (message "(No files need saving)")))))

(provide 'd-debugger)
