

(defun flm-string-contains-regexp--no-strings-no-comments (major-mode-name string contains-regexp start)
  "Returns (match-beginning 0) and (match-end 0) etc. to the caller."
  (let (found result (d-message-on nil))
    (with-temp-buffer
      (funcall major-mode-name)
      (d-assert (and (bobp) (eobp)))
      (insert string)
      (font-lock-fontify-buffer)
      (c++2lisp++-stage-1-purge-comments t)
      (goto-char (point-min))
      (goto-char start)
      (setq found (flm-re-search-forward--no-strings contains-regexp nil t))
      ) ;; END LET!
    ))

(defun flm-re-search-forward--no-strings (regexp &optional bound noerror count)
  "Returns (match-beginning 1) and (match-end 1) etc. to caller"
  (let ((done   nil)
        (found  nil)
        (p      nil)
        (p-orig nil))
    (setq p-orig (point))
    (while (not done)
      (if (setq found (re-search-forward regexp bound noerror count))
          (if (not (flm-inside-string))
              (progn
                ;;(setq found t)
                (setq done t)
                (setq p (point))))
        (progn
          (setq found nil)
          (setq done t)
          (if (and (not (eq noerror t)) (not (eq noerror nil)))
              (setq p (point-max))
            (setq p p-orig))
          )))
    (goto-char p)
    found))

;; (flm-re-search-forward--no-strings-no-comments "done" nil t)
(defun flm-re-search-forward--no-strings-no-comments (regexp &optional bound noerror count)
  "Returns (match-beginning 1) and (match-end 1) etc. to caller"
  (let ((done   nil)
        (found  nil)
        (p      nil)
        (p-orig nil))
    (setq p-orig (point))
    (while (not done)
      (if (setq found (re-search-forward regexp bound noerror count))
          (if (not (flm-inside-string-or-comment))
              (progn
                ;;(setq found t)
                (setq done t)
                (setq p (point))))
        (progn
          (setq found nil)
          (setq done t)
          (if (and (not (eq noerror t)) (not (eq noerror nil)))
              (setq p (point-max))
            (setq p p-orig))
          )))
    (goto-char p)
    found))

(defun flm-inside-string ()
  (let ((p (cadr (text-properties-at (point)))))
    (or
     (eq p 'font-lock-string-face)
     (eq p 'font-lock-doc-string-face)
     ))
  )

(defun flm-inside-string-or-comment ()
  (let ((p (cadr (text-properties-at (point)))))
    (or
     (eq p 'font-lock-string-face)
     (eq p 'font-lock-doc-string-face)
     (eq p 'font-lock-comment-face)
     (eq p 'd-face-super-comment)))
  )

(defun warn--find-enclosing-package ()
  (save-excursion
    (save-match-data
      (goto-char (point-min))
      (if (flm-re-search-forward--no-strings-no-comments "^package \\([a-z.]+\\);" nil t)
          (setq package (buffer-substring-no-properties (match-beginning 1) (match-end 1)))
        (setq package ""))
      package)
    ))

(provide 'd-flm)

