
;; (d-make-face 'red-face (setq bgcolor bg-colour) "red" :bold)
(defmacro d-make-face (font bgcolor fgcolor &rest rest)
  ;;(d-debug "Queen / Another one bites the dust")
  (d-assert (symbolp 'font))
  (d-assert (if (boundp 'font)
                (symbolp 'font)
              t))
  ;;(d-debug "Calamansi")
  (let (p was-error
          bold unbold
          italic unitalic
          underline ununderline)
    ;;(d-debug "The Shape of Jazz to Come / Chronology")
    ;;(d-debug "Queen / Fat Bottomed Girls")
    (setq bgcolor (eval bgcolor))
    (setq fgcolor (eval fgcolor))
    ;;(message "bgcolor=%s fgcolor=%s" bgcolor fgcolor)
    ;;(progn (setq bgcolor "#ffffff") (setq fgcolor "#000") (setq font 'fg:white))
    (setq p `(progn
               (if (not (eq 'font 'default))
                   (kill-local-variable (quote , font)))
               (setq , font (quote , font))
               (make-face (quote , font))
               (set-face-background (quote , font) , bgcolor)
               (set-face-foreground (quote , font) , fgcolor)))
    (setq ptr rest)
    ;;(d-debug "The Shape of Jazz to Come / Congeniality")
    (while ptr
      (cond
       ((or (null    (car ptr))
            (stringp (car ptr)))
        )
       ;; ------------------------------------------------------------
       ((or (eq (car ptr) :bold) (eq (car ptr) :unbold))
        (if (eq (car ptr) :bold)
            (setq bold t))
        (if (eq (car ptr) :unbold)
            (setq unbold t))
        (when (and bold unbold)
          (setq was-error (concat
                           was-error
                           "Both symbols should not be defined: :bold and :unbold,")))
        (if bold
            (setq p `(progn
                       , p
                         (make-face-bold (quote , font)))))
        (if unbold
            (setq p `(progn
                       , p
                         (make-face-unbold (quote , font))))
          ))
       ;; ------------------------------------------------------------
       ((or (eq (car ptr) :italic) (eq (car ptr) :unitalic))
        (if (eq (car ptr) :italic)
            (setq italic t))
        (if (eq (car ptr) :unitalic)
            (setq unitalic t))
        (when (and italic unitalic)
          (setq was-error (concat
                           was-error
                           "Both symbols should not be defined: :italic and :unitalic,")))
        (if italic
            (setq p `(progn
                       , p
                         (make-face-italic (quote , font)))))
        (if unitalic
            (setq p `(progn
                       , p
                         (make-face-unitalic (quote , font))))
          ))
       ;; ------------------------------------------------------------
       ((or (eq (car ptr) :underline) (eq (car ptr) :ununderline))
        (when (eq (car ptr) :underline)
          (setq u-or-uu   t)
          (setq underline t))
        (when (eq (car ptr) :ununderline)
          (setq u-or-uu nil)
          (setq ununderline t))
        (when (and underline ununderline)
          (setq was-error (concat
                           was-error
                           "Both symbols should not be defined: :underline and :ununderline,")))
        (setq p `(progn
                   , p
                     (set-face-underline (quote , font) u-or-uu))))
       ;; ------------------------------------------------------------
       (t ;; (setq was-error "Schmu")
        ;;(d-debug "Calamansi")
        (if (not (car ptr))
            (debug))
        (setq was-error (format "%s, FOO! unrecognised symbol: %s"
                                was-error
                                (car ptr)))
        (error (format "%s Unrecognised keyword %s" was-error (car ptr))))
       )
      (setq ptr (cdr ptr))) ;; END WHILE! ptr
    ;; ------------------------------------------------------------
    (if was-error
        (d-error (concat was-error " in macro d-make-face."))
      )
    p)
  )
;; (d-amiga-color (setq rgb-components "#fff"))
(defun d-amiga-color (rgb-components)
  "Allows for entry into the Amiga colour-space with 12 bits of
  colour for a total of 4096 different colours."
  (cond
   ((= (length rgb-components) 7)
    rgb-components)
   ((= (length rgb-components) 4)
    (let (r g b)
      (setq r (substring rgb-components 1 2))
      (setq g (substring rgb-components 2 3))
      (setq b (substring rgb-components 3 4))
      (setq rgb-components (concat "#" r r g g b b))
      ))))

(defun d-font-lock-add-begin (keywords)
  (if (fboundp 'font-lock-add-keywords)
      (font-lock-add-keywords nil keywords nil)
    (setq font-lock-keywords
          (append
           keywords
           font-lock-keywords))))

(defun d-font-lock-add-end (keywords)
  (if (fboundp 'font-lock-add-keywords)
      (font-lock-add-keywords nil keywords 'end)
    (setq font-lock-keywords
          (append
           font-lock-keywords
           keywords))))

(progn
  (kill-local-variable 'nil)
  (kill-local-variable 'prefs-bg-black-p)
  (kill-local-variable 'bg-colour-inverted)
  (setq bg-colour      "#000")
  (setq prefs-bg-black-p   t)
  (safe-require 'rgb-inverted)
  (setq bg-colour-inverted (rgb-inverted bg-colour))
  )

;; ordinary comment
;;; super comment
;;(d-beeps "Inside d-make-face-1")
(d-make-face font-lock-comment-face ;; TRUCK ME!
             nil
             (if prefs-bg-black-p "#88ff88" "#070")
             :italic)
(d-make-face bold nil bg-colour-inverted :bold)
(d-make-face d-face-el-d-stuff-2
             nil
             (if prefs-bg-black-p
                 "#fff" "#88c")
             :bold)
(d-make-face font-lock-keyword-face
             nil
             (if prefs-bg-black-p "#fff" "#000")
             :bold)
(d-make-face d-face-super-comment
             nil
             (if prefs-bg-black-p "#e44" "#f00")
             :italic :bold)
    ;;; adksajdjk
(d-make-face font-lock-constant-face nil "#f00" :bold)

;;(if abc)
;;      apple is in the comment face
" I am in string face... "
"     apple     "
(d-make-face font-lock-type-face nil "#88f" :bold)
(d-make-face font-lock-variable-name-face
             nil
             (if prefs-bg-black-p "#f8f" "#8800ff")
             :unbold
             :unitalic)
(d-make-face font-lock-function-name-face
             (if prefs-bg-black-p
                 "#000000" "#ffff00")
             (if prefs-bg-black-p
                 "#ffff00" "#000000")
             :bold)
(d-make-face font-lock-doc-face nil "#ff0000" :bold :italic)
;;(message "*** d-make-face-1 font-lock-doc-face bg-colour=%s" bg-colour)
(d-make-face dd-face nil "#00f")

(progn
  (d-make-face dired-marked  "#9999ff" "#ffffff")
  (d-make-face dired-flagged "#ff9999" "#ffffff")
  )

(progn
  (d-make-face d-face-cc-digits nil "#f0f" :bold)
  (d-make-face d-face-defmacro nil "#f80"  :bold)
  )

(progn
  (d-make-face redb-face nil "#f00" :bold)
  (d-make-face grnb-face nil "#0c0" :bold)
  (d-make-face blub-face nil "#00f" :bold)
  )
(progn
  (d-make-face red-face nil "#f00" :bold)
  (d-make-face grn-face nil "#0c0" :bold)
  (d-make-face blu-face nil "#66f" :bold)
  )
(d-make-face font-lock-string-face
             (if prefs-bg-black-p "#88f" (d-amiga-color "#ddf"))
             (if prefs-bg-black-p "#fff" "#000")
             )
" I am a string in font-lock-string-face... "
(d-make-face d-face-el-d-stuff   nil (if prefs-bg-black-p "#66f" "#00f") :bold)
(d-make-face d-face-el-quote     nil (if prefs-bg-black-p "#8f8" "#0a0") :bold)
(d-make-face bg:yellow
             (if prefs-bg-black-p nil "#ffff00")
             (if prefs-bg-black-p "#ffff00" "#000")
             :bold)
(d-make-face d-face-path      nil "#0c0")
(d-make-face d-face-makefile-space "#f0f" "#fff")
(d-make-face d-face-cc-global nil (if prefs-bg-black-p "#0c0" "#0c0") :bold)
(d-make-face fg:lightgreen nil "#080")
(d-make-face d-face-cc-debugging "#f0f" "white")
(d-make-face fg:white bg-colour-lighter bg-colour-inverted :bold)
(d-make-face d-face-path nil "#080")
(d-make-face d-face-cc-digits nil "#f0f")
(d-make-face d-face-property nil "#f80")
(d-make-face d-face-property-inverse "#f80" nil)
(d-make-face d-face-m4 "#f44" "#fff")
(d-make-face d-face-makefile-space nil "#f00")
(d-make-face bg:yellow nil (d-amiga-color "#ff0"))
(d-make-face bg:lightmagenta "#f0f" "white" :bold)
(d-make-face bg:lightred     "#f00" "white" :bold)
(d-make-face bg:lightgreen   "#0f0" "white" :bold)
(d-make-face bg:lightblue    "#00f" "lightblue" :bold)
;;(d-make-face fg:white "white" "black" :bold)
(d-make-face fg:red nil "#f00" :bold)
;;(d-make-face fg:red nil (rgb-invert nil) :bold)
(d-make-face d-face-m5 "#080" "#fff" :bold)
(d-make-face d-face-cc-debug "#080" "#fff" :bold)
(d-make-face blu-face nil "#00f" :bold)
(d-make-face lisp++-face-keywords nil "#00f" :bold)
(d-make-face d-debug-face      nil "#f0f" :bold)
(d-make-face d-checkpoint-face nil "#404" :bold)
(d-make-face lisp++-face-illegal-type "#0ff" "#f0f" :bold)
