

;; (d-make-face 'red-face (setq bgcolor bg-colour) "red" :bold)
(defmacro d-make-face (font bgcolor fgcolor &rest rest)
  ;;(d-debug "Queen / Another one bites the dust")
  (d-assert (symbolp 'font))
  (d-assert (if (boundp 'font)
                (symbolp 'font)
              t))
  ;;(d-debug "Calamansi")
  (let (p was-error
          bold unbold
          italic unitalic
          underline ununderline)
    ;;(d-debug "The Shape of Jazz to Come / Chronology")
    ;;(d-debug "Queen / Fat Bottomed Girls")
    (setq bgcolor (eval bgcolor))
    (setq fgcolor (eval fgcolor))
    ;;(message "bgcolor=%s fgcolor=%s" bgcolor fgcolor)
    ;;(progn (setq bgcolor "#ffffff") (setq fgcolor "#000") (setq font 'fg:white))
    (setq p `(progn
               (if (not (eq 'font 'default))
                   (kill-local-variable (quote , font)))
               (setq , font (quote , font))
               (make-face (quote , font))
               (set-face-background (quote , font) , bgcolor)
               (set-face-foreground (quote , font) , fgcolor)))
    (setq ptr rest)
    ;;(d-debug "The Shape of Jazz to Come / Congeniality")
    (while ptr
      (cond
       ((or (null    (car ptr))
            (stringp (car ptr)))
        )
       ;; ------------------------------------------------------------
       ((or (eq (car ptr) :bold) (eq (car ptr) :unbold))
        (if (eq (car ptr) :bold)
            (setq bold t))
        (if (eq (car ptr) :unbold)
            (setq unbold t))
        (when (and bold unbold)
          (setq was-error (concat
                           was-error
                           "Both symbols should not be defined: :bold and :unbold,")))
        (if bold
            (setq p `(progn
                       , p
                         (make-face-bold (quote , font)))))
        (if unbold
            (setq p `(progn
                       , p
                         (make-face-unbold (quote , font))))
          ))
       ;; ------------------------------------------------------------
       ((or (eq (car ptr) :italic) (eq (car ptr) :unitalic))
        (if (eq (car ptr) :italic)
            (setq italic t))
        (if (eq (car ptr) :unitalic)
            (setq unitalic t))
        (when (and italic unitalic)
          (setq was-error (concat
                           was-error
                           "Both symbols should not be defined: :italic and :unitalic,")))
        (if italic
            (setq p `(progn
                       , p
                         (make-face-italic (quote , font)))))
        (if unitalic
            (setq p `(progn
                       , p
                         (make-face-unitalic (quote , font))))
          ))
       ;; ------------------------------------------------------------
       ((or (eq (car ptr) :underline) (eq (car ptr) :ununderline))
        (when (eq (car ptr) :underline)
          (setq u-or-uu   t)
          (setq underline t))
        (when (eq (car ptr) :ununderline)
          (setq u-or-uu nil)
          (setq ununderline t))
        (when (and underline ununderline)
          (setq was-error (concat
                           was-error
                           "Both symbols should not be defined: :underline and :ununderline,")))
        (setq p `(progn
                   , p
                     (set-face-underline (quote , font) u-or-uu))))
       ;; ------------------------------------------------------------
       (t ;; (setq was-error "Schmu")
        ;;(d-debug "Calamansi")
        (if (not (car ptr))
            (debug))
        (setq was-error (format "%s, FOO! unrecognised symbol: %s"
                                was-error
                                (car ptr)))
        (error (format "%s Unrecognised keyword %s" was-error (car ptr))))
       )
      (setq ptr (cdr ptr))) ;; END WHILE! ptr
    ;; ------------------------------------------------------------
    (if was-error
        (d-error (concat was-error " in macro d-make-face."))
      )
    p)
  )
;; (d-amiga-color (setq rgb-components "#fff"))
(defun d-amiga-color (rgb-components)
  "Allows for entry into the Amiga colour-space with 12 bits of
  colour for a total of 4096 different colours."
  (cond
   ((= (length rgb-components) 7)
    rgb-components)
   ((= (length rgb-components) 4)
    (let (r g b)
      (setq r (substring rgb-components 1 2))
      (setq g (substring rgb-components 2 3))
      (setq b (substring rgb-components 3 4))
      (setq rgb-components (concat "#" r r g g b b))
      ))))

(defun d-font-lock-add-begin (keywords)
  (if (fboundp 'font-lock-add-keywords)
      (font-lock-add-keywords nil keywords nil)
    (setq font-lock-keywords
          (append
           keywords
           font-lock-keywords))))

(defun d-font-lock-add-end (keywords)
  (if (fboundp 'font-lock-add-keywords)
      (font-lock-add-keywords nil keywords 'end)
    (setq font-lock-keywords
          (append
           font-lock-keywords
           keywords))))

(progn
  (kill-local-variable 'nil)
  (kill-local-variable 'prefs-bg-black-p)
  (kill-local-variable 'bg-colour-inverted)
  (setq bg-colour      "#000")
  (setq prefs-bg-black-p   t)
  (safe-require 'rgb-inverted)
  (setq bg-colour-inverted (rgb-inverted bg-colour))
  )

;; ordinary comment
;;; super comment
;;(d-beeps "Inside d-make-face-1")
(d-make-face font-lock-comment-face ;; TRUCK ME!
             nil
             (if prefs-bg-black-p "#88ff88" "#070")
             :italic)
(d-make-face bold nil bg-colour-inverted :bold)
(d-make-face d-face-el-d-stuff-2
             nil
             (if prefs-bg-black-p
                 "#fff" "#88c")
             :bold)
(d-make-face font-lock-keyword-face
             nil
             (if prefs-bg-black-p "#fff" "#000")
             :bold)
(d-make-face d-face-super-comment
             nil
             (if prefs-bg-black-p "#e44" "#f00")
             :italic :bold)
    ;;; adksajdjk
(d-make-face font-lock-constant-face nil "#f00" :bold)

;;(if abc)
;;      apple is in the comment face
" I am in string face... "
"     apple     "
(d-make-face font-lock-type-face nil "#88f" :bold)
(d-make-face font-lock-variable-name-face
             nil
             (if prefs-bg-black-p "#f8f" "#8800ff")
             :unbold
             :unitalic)
(d-make-face font-lock-function-name-face
             (if prefs-bg-black-p
                 "#000000" "#ffff00")
             (if prefs-bg-black-p
                 "#ffff00" "#000000")
             :bold)
(d-make-face font-lock-doc-face nil "#ff0000" :bold :italic)
;;(message "*** d-make-face-1 font-lock-doc-face bg-colour=%s" bg-colour)
(d-make-face dd-face nil "#00f")

(progn
  (d-make-face dired-marked  "#9999ff" "#ffffff")
  (d-make-face dired-flagged "#ff9999" "#ffffff")
  )

(progn
  (d-make-face d-face-cc-digits nil "#f0f" :bold)
  (d-make-face d-face-defmacro nil "#f80"  :bold)
  )

(progn
  (d-make-face redb-face nil "#f00" :bold)
  (d-make-face grnb-face nil "#0c0" :bold)
  (d-make-face blub-face nil "#00f" :bold)
  )
(progn
  (d-make-face red-face nil "#f00" :bold)
  (d-make-face grn-face nil "#0c0" :bold)
  (d-make-face blu-face nil "#66f" :bold)
  )
(d-make-face font-lock-string-face
             (if prefs-bg-black-p "#88f" (d-amiga-color "#ddf"))
             (if prefs-bg-black-p "#fff" "#000")
             )
" I am a string in font-lock-string-face... "
(d-make-face d-face-el-d-stuff   nil (if prefs-bg-black-p "#66f" "#00f") :bold)
(d-make-face d-face-el-quote     nil (if prefs-bg-black-p "#8f8" "#0a0") :bold)
(d-make-face bg:yellow
             (if prefs-bg-black-p nil "#ffff00")
             (if prefs-bg-black-p "#ffff00" "#000")
             :bold)
(d-make-face d-face-path      nil "#0c0")
(d-make-face d-face-makefile-space "#f0f" "#fff")
(d-make-face d-face-cc-global nil (if prefs-bg-black-p "#0c0" "#0c0") :bold)
(d-make-face fg:lightgreen nil "#080")
(d-make-face d-face-cc-debugging "#f0f" "white")
(d-make-face fg:white bg-colour-lighter bg-colour-inverted :bold)
(d-make-face d-face-path nil "#080")
(d-make-face d-face-cc-digits nil "#f0f")
(d-make-face d-face-property nil "#f80")
(d-make-face d-face-property-inverse "#f80" nil)
(d-make-face d-face-m4 "#f44" "#fff")
(d-make-face d-face-makefile-space nil "#f00")
(d-make-face bg:yellow nil (d-amiga-color "#ff0"))
(d-make-face bg:lightmagenta "#f0f" "white" :bold)
(d-make-face bg:lightred     "#f00" "white" :bold)
(d-make-face bg:lightgreen   "#0f0" "white" :bold)
(d-make-face bg:lightblue    "#00f" "lightblue" :bold)
;;(d-make-face fg:white "white" "black" :bold)
(d-make-face fg:red nil "#f00" :bold)
;;(d-make-face fg:red nil (rgb-invert nil) :bold)
(d-make-face d-face-m5 "#080" "#fff" :bold)
(d-make-face d-face-cc-debug "#080" "#fff" :bold)
(d-make-face blu-face nil "#00f" :bold)
(d-make-face lisp++-face-keywords nil "#00f" :bold)
(d-make-face d-debug-face      nil "#f0f" :bold)
(d-make-face d-checkpoint-face nil "#404" :bold)
(d-make-face lisp++-face-illegal-type "#0ff" "#f0f" :bold)

;;(d-make-face red-face nil "#f00" :bold)
;;(d-make-face red-face nil "#f00" :bold)
(d-make-face bg:yellow "#ffff00" "#000" :bold)
(d-make-face d-face-green-and-yellow "#8f8" "#000" :bold)
(d-make-face fg:orange nil (d-amiga-color "#f80"))

;;(d-make-face 'FONT BGCOLOR FGCOLOR &rest REST)
(progn
  (d-make-face red-face nil "#e33" :bold)
  (d-make-face grn-face nil "#0c0" :bold)
  (d-make-face blu-face nil "#55f" :bold)
  )

(progn
  ;; I am a comment
    ;;; I am a super comment
  )

(progn
  (d-make-face underline nil nil :underline)
  ;; (d-make-face face bgcolor fgcolor bold? italic?)
  (d-make-face match "#ffff00" "#000" :bold)
  )

(progn
  (make-face 'font-lock-regexp-grouping-backslash)
  (set-face-foreground 'font-lock-regexp-grouping-backslash "#080")
  (set-face-background 'font-lock-regexp-grouping-backslash "#ccf")
  (make-face 'font-lock-regexp-grouping-construct)
  (set-face-foreground 'font-lock-regexp-grouping-construct "#080")
  (set-face-background 'font-lock-regexp-grouping-construct "#ccf")
  )

(progn ;; blue:

  (make-face 'fg:blue)
  (if prefs-bg-black-p
      (set-face-foreground 'fg:blue "#6666ff")
    (set-face-foreground 'fg:blue "#0000ff")
    (make-face-bold 'fg:blue))

  (d-make-face fg:lightblue
               nil
               (if prefs-bg-black-p "#77aaff" "#0000ff")
               :bold)

  )

(progn ;; brown:

  (make-face 'bg:brown)
  (set-face-background 'bg:brown "#aa7755")
  (set-face-foreground 'bg:brown nil)
  (make-face 'fg:brown)
  (make-face-bold 'fg:brown)
  (set-face-foreground 'fg:brown "#aa7755"))

(progn ;; cyan:

  (make-face 'fg:cyan)
  (make-face-bold 'fg:cyan)
  (set-face-foreground 'fg:cyan "dark cyan")

  (make-face 'fg:lightcyan)
  (make-face-bold 'fg:lightcyan)
  (if prefs-bg-black-p
      (set-face-foreground 'fg:lightcyan "#0ff")
    (set-face-foreground 'fg:lightcyan "#0aa"))
  (set-face-background 'fg:lightcyan nil)
  (setq fg:lightcyan 'fg:lightcyan)

  (make-face 'fg:cyan)
  (make-face 'bg:cyan)
  (set-face-background 'bg:cyan "dark cyan")
  (set-face-foreground 'bg:cyan nil))

(progn ;; gray:

  (d-make-face fg:darkgray "#888" "#fff")
  (d-make-face bg:lightgray "#ccc" "black")
  (d-make-face fg:lightgray
               nil
               (if prefs-bg-black-p "#ccc" "#000"))
  )

(progn ;; green:

  (make-face 'fg:green)
  (make-face-bold 'fg:green)
  (if prefs-bg-black-p
      (set-face-foreground 'fg:green "#0b0")
    (set-face-foreground 'fg:green "#0b0"))

  (d-make-face dark-blue nil (d-amiga-color "#00a") :bold)

  (make-face 'bg:green)
  (set-face-background 'bg:green "#00cc00")
  (set-face-foreground 'bg:green nil)

  (make-face 'bg:lightgreen)
  (set-face-background 'bg:lightgreen "lightgreen")
  (set-face-foreground 'bg:lightgreen "black")

  (make-face 'fg:lightgreen)
  (if prefs-bg-black-p
      (set-face-foreground 'fg:lightgreen "#0d4")
    (set-face-foreground 'fg:lightgreen "#5c5"))
  (if (not prefs-bg-black-p)
      (make-face-bold 'fg:lightgreen))
  )

(progn
  (make-face 'd-checkpoint-face)
  (set-face-foreground 'd-checkpoint-face "#c0c")
  (set-face-background 'd-checkpoint-face "#fff")
  (make-face-bold 'd-checkpoint-face)
  )

(progn
  (make-face 'd-debug-face)
  (set-face-background 'd-debug-face "#fff")
  (make-face-bold 'd-debug-face)
  )

(progn ;; magenta:
  (d-make-face fg:magenta nil "magenta" :bold)
  (d-make-face bg:magenta "magenta" nil :bold)
  (d-make-face fg:lightmagenta nil "#f0f" :bold)
  (d-make-face red-face nil (if prefs-bg-black-p
                                "red"
                              "red")
               :bold)
  (d-make-face green-face nil (if prefs-bg-black-p
                                  "green"
                                "green")
               :bold)
  (d-make-face blue-face  nil (if prefs-bg-black-p
                                  "blue"
                                "blue")
               :bold)

  (d-make-face bg:lightmagenta "magenta" nil :bold)
  )
(progn ;; red:
  (d-make-face fg:red nil "red" :bold)
  (d-make-face bg:red "red" nil :bold)
  (progn
    ;;(d-make-face 'FONT BGCOLOR FGCOLOR &rest REST)
    (d-make-face fg:lightred nil   "#f33" :bold)
    (d-make-face bg:lightred "red" nil    :bold)
    ))

(progn ;; WHITE:
  (d-make-face fg:white
               nil
               (if prefs-bg-black-p
                   bg-colour-inverted
                 "black")
               )
  )
(progn ;; YELLOW:

  (setq fg:yellow 'fg:yellow)
  (make-face 'fg:yellow)
  (make-face-bold 'fg:yellow)
  (if prefs-bg-black-p
      (progn
        (set-face-foreground 'fg:yellow "yellow")
        (set-face-background 'fg:yellow nil))
    (progn
      (set-face-foreground 'fg:yellow "yellow")
      (set-face-background 'fg:yellow "black")))

  (d-make-face bg:yellow (d-amiga-color "#ff0") "#000" :bold)
  )
(progn
  (make-face 'd-face-blue-and-white)
  (set-face-foreground 'd-face-blue-and-white (if prefs-bg-black-p "white" "white"))
  (set-face-background 'd-face-blue-and-white
                       (cond
                        (prefs-bg-black-p "#44c")
                        (t "#9999ff")))
  )

(d-make-face d-face-red-and-white "red" "white" :bold)

(d-make-face d-face-red-and-yellow "#e00" "#ff0" :bold)

(d-make-face d-face-green-and-black
             (if prefs-bg-black-p "white" "black")
             (if prefs-bg-black-p "#080" "#8f8")
             :bold)

(d-make-face d-face-green-and-yellow
             (if prefs-bg-black-p "#080" "#8f8")
             (if prefs-bg-black-p "#ff0" "#000000")
             :bold)
(progn
  (copy-face 'fg:lightred 'd-face-link)
  (set-face-underline-p 'd-face-link t))

(progn
  (copy-face 'fg:lightblue 'd-face-line)
  (set-face-underline-p 'd-face-line t))

(progn
  (if prefs-bg-black-p
      (copy-face 'fg:cyan 'd-face-html-entity)
    (make-face 'd-face-html-entity))
  (make-face-bold 'd-face-html-entity))


(progn
  (d-make-face d-face-fuck     "#844" (d-amiga-color "#ff0") :bold)
  (d-make-face d-face-cc-stars "#080" (d-amiga-color "#ff0") :bold)
  (d-make-face lisp++-face-lightred   nil "#ff0000")
  )

(d-quote 123)

(progn
  (d-make-face d-face-el-local-variables nil "#0c0" :bold)
  (d-make-face d-face-lisp++-keywords    nil "#0c0" :bold)
  )

(progn
  (make-face 'd-face-property)
  (make-face-bold 'd-face-property)
  (set-face-foreground 'd-face-property "#f90")

  (make-face 'd-face-property-inverse)
  (make-face-bold 'd-face-property-inverse)
  (set-face-background 'd-face-property-inverse (d-amiga-color "#f90"))
  (set-face-foreground 'd-face-property-inverse (d-amiga-color "#000")))

;; oridinary comment appears in font-lock-comment-face
  ;;; super comment    appears in d-face-super-comment
;;(d-make-face d-face-super-comment nil "red" :bold :italic)

(d-assert (or (string= "#fff" bg-colour)
              (string= "#000" bg-colour)))

(copy-face 'd-face-super-comment 'font-lock-doc-face)
(copy-face 'd-face-super-comment 'font-lock-doc-string-face)

(progn
  ;; MY CPLUSPLUS FACES:
  (make-face 'd-face-cc-clib)
  (make-face-bold 'd-face-cc-clib)
  (set-face-foreground 'd-face-cc-clib (if prefs-bg-black-p (d-amiga-color "#a88") (d-amiga-color "#844")))
  (copy-face 'd-face-cc-clib 'd-face-cc-allegro)
  (copy-face 'd-face-cc-clib 'd-face-cc-libd)
  (copy-face 'd-face-cc-clib 'd-face-cc-opengl)

  (make-face 'd-face-cc-ctor-dtor)
  (set-face-foreground 'd-face-cc-ctor-dtor (if prefs-bg-black-p (d-amiga-color "#f44") (d-amiga-color "#f0f")))
  (make-face-bold 'd-face-cc-ctor-dtor)
)

(progn
  (make-face 'd-face-cc-debugging)
  (set-face-background 'd-face-cc-debugging "green")
  (make-face-bold 'd-face-cc-debugging))

(progn
  (d-make-face d-face-cc-private "#ffbbbb" "black" :bold)
  (d-make-face d-face-m4-dnl  "#c80" "black" :bold)
  )

(progn
  (d-make-face d-face-special-reference
               (d-amiga-color "#666")
               (d-amiga-color "#fff") :bold)
  (if prefs-bg-black-p
      (progn
        (set-face-foreground 'd-face-special-reference (d-amiga-color "#fff"))
        (set-face-background 'd-face-special-reference (d-amiga-color "#666")))
    (progn
      (set-face-foreground 'd-face-special-reference "black")
      (set-face-background 'd-face-special-reference bg-colour-lighter))))
  
  (if (not (and os-type-mswindows-p emacs-dialect-gnuemacs-p))
      (make-face-bold 'd-face-special-reference))
  
  (d-make-face d-face-makefile-space
     nil
     "#f0f")
  
  (d-make-face d-face-makefile-tab
     (if prefs-bg-black-p "#848" (d-amiga-color "#cfc"))
             (if prefs-bg-black-p "#fff" "#fff")
             )
(copy-face 'd-face-red-and-white 'd-face-linefeed)

(d-make-face d-face-m4
             "#f00"
             (if prefs-bg-black-p "#fff" "#fff")
             :bold)

(d-make-face d-face-m5
             "lightgreen"
             "black"
             :bold)

(d-make-face d-face-m6
             (d-amiga-color "#ccf")
             "black"
             :bold)

(progn
  (make-face 'd-face-cc-illegal-type)
  (make-face-bold 'd-face-cc-illegal-type)
  (set-face-foreground 'd-face-cc-illegal-type "red")
  (set-face-background 'd-face-cc-illegal-type (d-amiga-color "#0ff"))
  (copy-face 'd-face-cc-illegal-type 'd-face-cc-searching)
  )

(progn
  (make-face 'd-face-makefile-dollar-dollar)
  (set-face-background 'd-face-makefile-dollar-dollar (if prefs-bg-black-p (d-amiga-color "#090") (d-amiga-color "#8f8")))
  (set-face-foreground 'd-face-makefile-dollar-dollar (if prefs-bg-black-p (d-amiga-color "#fff") "#000000"))
  (copy-face 'd-face-makefile-dollar-dollar 'd-face-makefile-dollar-dollar-highlight)
  (make-face-bold 'd-face-makefile-dollar-dollar-highlight)
  ;;(make-face 'd-face-makefile-dollar-dollar-highlight)
  ;;(set-face-background 'd-face-makefile-dollar-dollar-highlight (if prefs-bg-black-p (d-amiga-color "#8b0") (d-amiga-color "#8f8")))
  ;;(set-face-foreground 'd-face-makefile-dollar-dollar-highlight (if prefs-bg-black-p (d-amiga-color "#ff0") (d-amiga-color "#fff")))
  )

(progn
  (make-face 'mmm-default-submode-face)
  (set-face-foreground 'mmm-default-submode-face nil)
  ;;(set-face-foreground 'mmm-default-submode-face (d-amiga-color "#fff"))
  (set-face-background 'mmm-default-submode-face nil)
  (make-face-bold 'mmm-default-submode-face)
  ;;(make-face-unbold 'mmm-default-submode-face)
  )

(progn
  (copy-face 'd-face-cc-illegal-type 'd-face-cc-digits)
  (set-face-background 'd-face-cc-digits nil)

  (if prefs-bg-black-p
      (progn
        (set-face-background 'd-face-cc-digits (d-amiga-color "#666"))
        (set-face-foreground 'd-face-cc-digits (d-amiga-color "#fff"))
        )
    ;;(set-face-foreground 'd-face-cc-digits "#000000")
    ;;(set-face-background 'd-face-cc-digits "#e8d4ff")
    (set-face-background 'd-face-cc-digits nil)
    (set-face-foreground 'd-face-cc-digits (d-amiga-color "#f0f")))

  )

(progn
  (setq ediff-even-diff-B 'ediff-even-diff-B)
  (make-face 'ediff-even-diff-B)
  (set-face-foreground 'ediff-even-diff-B (d-amiga-color "#fff"))
  )

(progn
  (setq ediff-even-diff-A 'ediff-even-diff-A)
  (make-face 'ediff-even-diff-A)
  (set-face-background 'ediff-even-diff-A (d-amiga-color "#0f0"))
  (set-face-foreground 'ediff-even-diff-A (d-amiga-color "#fff")))

(progn
  (make-face 'match)
  (set-face-foreground 'match (d-amiga-color "#000"))
  (set-face-background 'match "#ffee00"))
(progn
  ;;
  ;; NOTE: Version 22 bindings
  ;;
  (make-face 'mode-line-buffer-id)
  (make-face 'tabbar-default-face)
  (set-face-foreground 'tabbar-default-face "#000000")
  (set-face-background 'tabbar-default-face (d-amiga-color "#eee"))
  )

(progn
  (make-face 'underline)
  (set-face-underline-p 'underline t))

(progn
  (make-face 'bold-underline)
  (make-face-bold 'bold-underline)
  (set-face-underline-p 'bold-underline t))
;;
;;  (progn
;;    (make-face 'bold-italic)
;;    (make-face-bold 'bold-italic)
;;    (make-face-italic 'bold-italic))
;;
;;(set-face-foreground 'italic (d-amiga-color "#0af"))
;;(set-face-foreground 'bold (d-amiga-color "#dd0"))
;;(copy-face 'fg:lightcyan             'bold-italic)
;;(copy-face 'bg:lightmagenta          'highlight)

(progn
  (set-face-foreground 'font-lock-type-face (if prefs-bg-black-p "#00ffff" "#0000ff"))
  (make-face-bold 'font-lock-type-face)
  )

(if prefs-bg-black-p
    (copy-face 'fg:white 'font-lock-reference-face)
  (copy-face 'fg:lightgray 'font-lock-reference-face))

(set-face-background 'font-lock-reference-face bg-colour-lighter)

(d-quote progn
         (if prefs-bg-black-p
             (copy-face 'fg:yellow 'font-lock-function-name-face)
           (copy-face 'bg:yellow 'font-lock-function-name-face))
         (make-face-bold 'font-lock-function-name-face))

(if prefs-bg-black-p
    (copy-face 'bg:green 'show-paren-match-face)
  (copy-face 'd-face-cc-illegal-type 'show-paren-match-face)
  (set-face-foreground 'show-paren-match-face (d-amiga-color "#000"))
  )
(if emacs-dialect-xemacs-p (copy-face 'show-paren-match-face 'paren-match))

(set-face-underline-p 'font-lock-reference-face t)

(progn
  (make-face 'font-lock-builtin-face)
  (make-face-bold 'font-lock-builtin-face)
  ;;(set-face-background 'font-lock-builtin-face (d-amiga-color "#0f0"))
  ;;(set-face-background 'font-lock-builtin-face bg-colour-lighter)
  )

(progn
  (let (bg fg)
    (progn
      (setq bg nil)
      (setq fg (if prefs-bg-black-p "#f88" "#000"))
      )
    (provide 'ppfpfpfp)
    ;;(d-make-face 'font-lock-constant-face nil fg :bold)
    ;;(d-make-face 'font-lock-keyword-face  nil "#f88" :bold)
    )
  )

(progn
  (make-face 'highlight)
  (set-face-foreground 'highlight (d-amiga-color "#fff"))
  (set-face-background 'highlight (d-amiga-color "#88f")))

(progn
  (make-face 'region)
  (set-face-foreground 'region (d-amiga-color "#fff"))
  (set-face-background 'region (if prefs-bg-black-p (d-amiga-color "#f4a") (d-amiga-color "#f8a"))))

(progn
  (make-face 'font-lock-warning-face)
  (set-face-foreground 'font-lock-warning-face "red")
  ;;(set-face-background 'font-lock-warning-face bg-colour-lighter)
  (make-face-bold 'font-lock-warning-face))

(if (not (and os-type-mswindows-p emacs-dialect-gnuemacs-p))
    (make-face-bold 'font-lock-warning-face))

(make-face 'secondary-selection)
(set-face-foreground 'secondary-selection "lightgreen")
(copy-face 'd-face-cc-searching 'secondary-selection)
(copy-face 'bg:lightmagenta 'info-menu-5)
(copy-face 'fg:lightcyan 'info-node)
(copy-face 'bold 'info-xref)
(set-face-underline-p 'info-xref t)
(set-face-foreground 'info-xref (d-amiga-color "#00f"))

(copy-face 'region                   'd-face-cc-searching)
(copy-face 'fg:darkgray              'dired-face-permissions)
(set-face-background                 'dired-face-permissions bg-colour-lighter)
(copy-face 'fg:white                 'modeline-buffer-id)
(copy-face 'bold 'dired-symlink)
(copy-face 'fg:green              'd-face-path)
;;(copy-face 'd-face-blue-and-white      'dired-face-marked)
;;(copy-face 'd-face-red-and-white       'dired-face-flagged)
(copy-face 'region                     'zmacs-region)
(copy-face 'region                     'primary-selection)
(copy-face 'font-lock-reference-face   'font-lock-preprocessor-face)
(copy-face 'fg:lightgray               'modeline-mousable)
(copy-face 'fg:red                     'modeline-mousable-minor-mode)

(copy-face (if prefs-bg-black-p 'fg:lightred 'fg:lightblue) 'diary-face)

(when emacs-dialect-xemacs-p
  (set-face-foreground 'blue       (d-amiga-color "#88f"))
  (copy-face 'fg:lightblue         'hyper-apropos-hyperlink)
  (copy-face 'fg:lightred          'hyper-apropos-documentation)
  (copy-face 'fg:lightblue         'custom-group-tag-face)
  (copy-face 'fg:darkgray          'dired-face-boring)
  (set-face-foreground             'dired-face-boring (d-amiga-color "#888"))
  (copy-face 'fg:lightgray         'dired-face-permissions)
  (set-face-foreground             'dired-face-permissions (d-amiga-color "#999"))
  (copy-face 'fg:lightcyan         'dired-face-symlink)
  ;;(copy-face 'd-face-green-and-yellow 'isearch)
  (copy-face 'd-face-green-and-white 'isearch-secondary)
  (copy-face 'bg:lightgray         'modeline-buffer-id)
  ;;(copy-face 'bg:lightgray 'widget-button-face)
  )

(progn
  (make-face 'isearch-lazy-highlight-face)
  (set-face-foreground 'isearch-lazy-highlight-face "#000000")
  (set-face-background 'isearch-lazy-highlight-face (d-amiga-color "#0ff")))

(copy-face 'd-face-blue-and-white  'secondary-selection)

(progn
  (set-face-background 'isearch "#000000")
  (set-face-foreground 'isearch "#ff0000")
  (make-face-bold 'isearch))
(copy-face 'fg:lightgreen 'eshell-ls-executable)
(copy-face 'fg:lightred   'eshell-ls-archive)
(copy-face 'font-lock-function-name-face 'match)
(safe-require 'd-syntax-highlighting-coding-preferences)
(d-make-face fg:lightred nil "red")
;;(d-make-face 'd-face-el-d-stuff-2 "#ccf" "#000" :bold)
;;(d-make-face 'grnb-face nil "#0f0" :bold)

;;;
;;; Feel free to change the colours of the items
;;;
(d-make-face dc-face-dired-executable nil "#0c0" :bold)

(d-make-face dc-face-dired-archives
             nil
             (if prefs-bg-black-p "#fcc" "#f44")
             :bold)

(d-make-face dc-face-dired-binaries nil "#f66" :bold)

;;(make-face 'dc-face-dired-fig)
;;(set-face-foreground 'dc-face-dired-fig "#0ff")
;;(make-face-bold 'dc-face-dired-fig)

(d-make-face dc-face-dired-graphics nil "#f4f" :bold)
(make-face 'dc-face-dired-movies)
(set-face-background 'dc-face-dired-movies "#f0f")
(set-face-foreground 'dc-face-dired-movies "#fff")
(make-face-bold 'dc-face-dired-movies)
(setq dc-face-dired-movies 'dc-face-dired-movies)

(make-face 'dc-face-dired-sounds)
(set-face-foreground 'dc-face-dired-sounds "#830")
(make-face-bold 'dc-face-dired-sounds)

(d-make-face dc-face-dired-web
             (if prefs-bg-black-p
                 "#000" "#ffff00")
             (if prefs-bg-black-p
                 "#ffff00" "#000")
             :bold)

(progn
  (make-face 'dc-face-dired-unimportant)
  (set-face-foreground 'dc-face-dired-unimportant "#888")
  (make-face-bold 'dc-face-dired-unimportant))

(d-make-face dc-face-dired-text nil (if prefs-bg-black-p "#fff" "#000"))
(make-face 'fg:lightblue)
(set-face-foreground 'fg:lightblue "#4455ff")

(progn
  (d-make-face dired-directory      nil "#88c" :bold)
  ;;(d-make-face dired-directory-face nil bg-colour-inverted)
  (d-make-face dc-face-directory      nil "#88c" :bold))

(progn
  (d-make-face dired-marked  "#00f" "#fff" :bold)
  (d-make-face dired-flagged "#f00" "#fff" :bold)
  )

(d-make-face dc-face-dired-sources
             nil
             bg-colour-inverted
             :bold)

(copy-face 'dc-face-dired-executable 'eshell-ls-product-face)

(d-make-face dc-face-symlinks "#fcc" "#f00" :bold)

(d-make-face global-face nil "#0c0")

(d-make-face orange nil "#f80" :bold)

(d-make-face lightgreen nil "#080" :bold :italic)

(progn
  (d-make-face dc-face-dired-unimportant nil nil)
  (d-make-face d-face-cc-debugging "#0f0" "#000" :bold)
  (d-make-face fg:lightgreen nil "#0a0" :bold)
  )
   
(provide 'd-make-face)
