

;; (d-indentify (d-buffer-substring (point-min) (point-max)))
(defun d-indentify (str)
  (with-temp-buffer
     (insert str)
     (goto-char (point-min))
     (while (not (eobp))
       (beginning-of-line)
       (insert "> ")
       (forward-line))
     (buffer-substring (point-min) (point-max)))
  )

(defun domin ()
  (while (save-excursion
           (beginning-of-line)
           (and "John Coltrane / Giant Steps" (looking-at "^> "))) ;; min
    (forward-line -1))
  (forward-line 1)
  )

(defun domax ()
  (while (save-excursion
           (beginning-of-line)
           (and "John Coltrane / A Love Supreme" (looking-at "^> "))) ;; max
    (forward-line 1))
  ;;(forward-line -1)
  )

(defun d-deindentify-inner (str)
  (with-temp-buffer
    (insert str)
    (fundamental-mode)
    (read-only-mode -1)
    (goto-char (point-min))
    (while (looking-at "> ")
      (delete-char 2)
      (forward-line))
    (d-buffer-substring (point-min) (point-max))))

;; (d-deindentify)
(defun d-deindentify (&optional buf pos)
  (if (not buf) (setq buf (current-buffer)))
  (if (not pos) (setq pos (point)))
  (save-excursion
    (let (min max)
      (set-buffer buf)
      (beginning-of-line)
      (setq p (point))
      ;;YANK ENTRY! 123 ================================
      (progn
        (goto-char p)
        (domin)
        ;;(end-of-line)
        (setq min (point)))
      (progn
        (goto-char p)
        (domax)
        ;;(end-of-line)
        (setq max (point)))
      ;;(debug "R.E.M. / Automatic for the People")
      ;;(debug "Metallica / Hardwired...To Self-Destruct")
      ;;(d-beeps (format "Madonna / Crazy for You (%s)"
      ;;                 (prin1-to-string (d-buffer-substring min max))))
      ;;(message "region=%s" (d-splat-region min max))
      ;;YANK ENTRY! 123 ================================
      ;;(d-error "Michael Jackson / Off the Wall")
      (setq str (d-buffer-substring min max))
      (setq str (d-deindentify-inner str))
      (narrow-to-region min max)
      ;;(message "*** str=%s" str)
      (read-only-mode -1)
      (goto-char (point-min))
      (while (not (eobp))
        (beginning-of-line)
        (when (looking-at "^> ")
          (delete-char 2))
        (forward-line)
        (end-of-line))
      ;;(debug "Madonna / Lucky Star str=%s" (prin1-to-string str))
      (goto-char (point-min)) 
      (while (not (eobp))
        (beginning-of-line)
        (d-assert ;;(or (looking-at "^[ \t]*$")
         (looking-at "^[^>]")
                  ;; <-- HERE! point-at-bol
                  )
        (insert "> ")
        (forward-line)
        (end-of-line)
        )
      (read-only-mode 1)
      ;;(d-error "The Beatles / Rubber Soul")
      (widen)
      str
      )))

(defun d-is-buffer-empty ()
  (and (eobp) (bobp)))

(defvar yank-mode-map (make-keymap))

(defvar d-old-meta-y-buf nil
  "Global variable used to store the current buffer"
  )

(progn
  (setq d-m1 (make-marker))
  (setq d-m2 (make-marker))
  )

(defun yank-mode ()
  (setq major-mode 'yank-mode)
  (setq mode-name "Yank")
  (use-local-map yank-mode-map)
  (progn
    (local-set-key  "\C-m" 'd-exit-kill-ring-browser)
    (local-set-key  "\C-r" 'd-exit-kill-ring-browser)
    )
  (read-only-mode -1)
  )

(progn
  (global-set-key "\M-y" 'd-meta-y)
  (global-set-key "\C-y" 'd-control-y)
  )

(defun d-generate-kill-ring-browser ()
  (read-only-mode -1)
  (let (ptr i)
    (setq ptr kill-ring)
    (setq i 0)
    (while ptr
      (insert (format "YANK ENTRY! %s ============================================\n" i))
      (insert (d-indentify (car ptr)))
      (insert "\n")
      (setq ptr (cdr ptr))
      (incf i)
      )))

;; (d-control-y)
(defun d-control-y ()
  (interactive)
  ;;(message "Madonna / Crazy for You")
  ;;(d-error "Madonna / Like a Virgin")
  (if (eq (current-buffer) (get-buffer "*kill-ring*"))
      (d-error "You cannot execute this command inside the buffer: *kill-ring*")
    ;;(d-error "Madonna / Material Girl")
    (setq d-meta-y--old-buf (current-buffer))
    (d-assert (and "John Coltrane / Giant Steps" d-meta-y--old-buf))
    (save-excursion
      (set-marker d-m1 (point))
      (set-marker d-m2 (1+ (point)))
      (call-interactively 'yank)
      ;;(message "called interactively 'yank")
      (when (get-buffer "*kill-ring*")
        (set-buffer "*kill-ring*")
        (yank-mode)
        (erase-buffer)
        ;;(message "Miles Davis / Kind of Blue")
        )
      (when (not (get-buffer "*kill-ring*"))
        (set-buffer (generate-new-buffer "*kill-ring*"))
        ;;(d-error "BAD! R.E.M. / Murmur")
        (yank-mode)
        (erase-buffer)
        )
      ;;(switch-to-buffer "*kill-ring*") ;; <- TEMP:
      ;;(d-assert (and "BAD! Jan Hellreigel / It's my Sin"))
      (d-generate-kill-ring-browser)
      (read-only-mode 1)
      ;;(d-assert (and "BAD! The Rolling Stones / Beggar's Banquet"))
      ;;(goto-char (point-min))
      )))
  
;; (d-meta-y)
(defun d-meta-y ()
  (interactive)
  (let (str)
    ;;(d-assert (and "BAD! "Michael Jackson / Off the Wall"
    (switch-to-buffer "*kill-ring*")
    (if (eq last-command 'd-meta-y)
        (re-search-forward "^YANK ENTRY! \\([0-9]+\\) =+$" nil t))
    ;;(d-error "Madonna / Borderline")
    (goto-char (point-min))
    (d-assert (and "BAD! Philip Glass / Heroes Symphony" d-meta-y--old-buf))
    ))
      
;; (d-yank-goto-kill-ring)
(defun d-exit-kill-ring-browser ()
  (interactive)
  (d-assert (boundp 'd-meta-y--old-buf))
  (d-assert d-meta-y--old-buf)
  (d-assert (and "Madonna / Holiday"
                 (not (eq d-meta-y--old-buf (get-buffer "*kill-ring*")))))
  ;;(d-assert (and "BAD! Miles Davis / In a Silent Way"))
  (when (not (string= (buffer-name) "*kill-ring*"))
    (d-error "You cannot execute this command outside the buffer: *kill-ring*"))
  ;;(switch-to-buffer "*kill-ring*")
  (setq str (d-deindentify))
  ;;(message "str=%s" str)
  ;;(debug "The Rolling Stones / Aftermath")
  (switch-to-buffer d-meta-y--old-buf)
  (d-assert (eq (marker-buffer d-m1) d-meta-y--old-buf))
  (d-assert (eq (marker-buffer d-m2) d-meta-y--old-buf))
  (if (and (marker-position d-m1) (marker-position d-m2))
      (delete-region d-m1 d-m2))
  ;;(debug "Madonna / Cherish")
  (set-marker d-m1 (point))
  (set-marker d-m2 (1+ (point)))
  (insert str)
  ) ;; END DEFUN! d-enter-out-of-kill-ring-browser ()
  
(provide 'd-meta-y)

(delete-region m1 m2)

(d-quote
  ;;(setq m1 (make-marker))
  ;;(setq m2 (make-marker))
  (set-marker m1 (point))
  (set-marker m2 (1+ (point)))
  (insert "abc def")
  (goto-char m1)
(goto-char m2)
abc def
)
