
;;; d-prefs.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-prefs.el
;; Author/Maintainer: Davin Max Pearson <http://davin.50webs.com>
;; Keywords: My GNU Emacs Preferences
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:

;; 1
(when (and os-type-linux-p emacs-dialect-gnuemacs-p)
  (setq backup-inhibited t)
  (setq backup-directory-alist '(("" . "~/.emacs.d")))
  (setq version-control t)
  (setq kept-new-versions 2)
  (setq kept-old-versions 2))

(when (and os-type-mswindows-p emacs-dialect-gnuemacs-p)
  (setq backup-inhibited t)
  (setq backup-directory-alist '(("" . "~/.emacs.d")))
  ;;(setq version-control t)
  ;;(setq kept-new-versions 2)
  ;;(setq kept-old-versions 2)
  )

(setq completion-ignored-extensions
      (append (list
               ".el.old" ".el.old.9" ".el.old.8" ".el.old.7" ".el.old.6"
               ".el.old.5" ".el.old.4" ".el.old.3" ".el.old.2" ".el.old.1"
               ".old4" ".old3" ".old2" ".old"
               ".oldel" ".old.el"
               ".out" ".exe" ".pif" ".com" ".class" ".tmp" ".tm4" ".num"
               ".dep" ".DEP" ".ps"  ".dvi" ".aux" ".log" ".tga" ".sys"
               ;; ".ctxt" Eclipse generated file
               )
              completion-ignored-extensions))

(d-quote setq dired-omit-extensions
         (append (list
                  ".num" ".temp")
                 dired-omit-extensions))

;;(setq completion-ignored-extensions (delete ".a" completion-ignored-extensions))
;;(setq completion-ignored-extensions (delete ".log" completion-ignored-extensions))

(setq dired-guess-shell-alist-user
      '(("\\.zip" "unzip")
        ("\\.wav" "playwav")
        ("\\.tga" "view")
        ("\\.pcx" "view")
        ))

;;
;; QUESTION: why does this not affect the status in the modeline?
;;
;; ANSWER: because it only sets in when you call eval-expression
;;
;;(setq eval-expression-debug-on-error nil)
;;(setq eval-expression-debug-on-error t)

;;; see d-start.el for setting debug-on-error

;;(setq debug-ignored-errors (remove "Containing expression ends prematurely" debug-ignored-errors))
(setq debug-ignored-errors (remove 'end-of-file debug-ignored-errors))
;;(setq debug-ignored-errors (remove 'search-failed debug-ignored-errors))

;;; (try-me)
(defun try-me ()
  (let ((a 123))
    (error "Schmu")))



(autoload 'pov-mode "d-povray.el")
;;(check-c-c-binding)

;;(setq-default outline-regexp "[\\-\\+]?\\**")

;;(setq same-window-buffer-names (cons "*compilation*" same-window-buffer-names))

;;(setq same-window-regexps
;;      (append
;;       (list "\\*compilation\\*" "\\*Backtrace\\*")
;;       same-window-regexps))

;;(setq same-window-regexps (cdr same-window-regexps))

(if emacs-dialect-xemacs-p
    (progn
      (line-number-mode 1)
      (paren-set-mode 2)
      (if (string= system-configuration "sparc-sun-solaris2.4")
          (setq visible-bell nil)
       )
      (setq zmacs-regions nil)
      )
  )

;;
;; NOTE: these variable appear to have no effect
;;
(d-quote
  (setq blink-cursor-interval 0.5)
  (setq blink-cursor-delay 0.5)
  (run-with-idle-timer 0.1 t 'blink-cursor-start))

(provide 'd-prefs)
