
;;; d-tidy-html-files.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-tidy-html-files.el
;; Author/Maintainer: Davin Max Pearson <http://davin.50webs.com>
;; Keywords: tidy html files functionality
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:

(require 'cl)

(defun doit ()
  (interactive)
  (setq *prefix* "~/hairy-lemon/output/50webs-com/")
  (message "*** *prefix*=%s" *prefix*)
  (condition-case err
      (progn
        (setq ptr-1 (directory-files *prefix* t "\\.html$"))
        (setq len (length ptr-1))
        (setq count 0)
        (while ptr-1
          (incf count)
          (find-file (car ptr-1))
          (message "Progress %s/%s (car ptr-1)=%s" count len (car ptr-1))
          (read-only-mode -1)
          (goto-char (point-min))
          (while (looking-at "[ \t\r\n]")
            (delete-char 1))
          (when (search-forward "-->" nil t)
            (forward-line 1)
            (beginning-of-line)
            (while (looking-at "[ \t\r\n]")
              (delete-char 1)))
          (save-buffer)
          (kill-buffer)
          (setq ptr-1 (cdr ptr-1)))
        )
    (error
     (message "Error in d-tidy-html-files.el err=%s"
              (prin1-to-string err))
     )
    )
  (condition-case err
      (progn
        (setq list (directory-files *prefix* t "\\.html$"))
        (setq ptr-2 list)
        (setq len   (length list))
        (setq count 0)
        (while ptr-2
          (incf count)
          (message "Progress %s/%s (car ptr-2)=%s" count len (car ptr-2))
          (find-file (car ptr-2))
          (read-only-mode -1)
          (goto-char (point-min))
          (while (re-search-forward "\C-m" nil t)
            (replace-match "" nil nil))
          (save-buffer)
          (kill-buffer)
          (setq ptr-2 (cdr ptr-2))))
    (error
     (message "Error in d-tidy-html-files.el err=%s"
              (prin1-to-string err))
     )))
