

(message "*** Welcome to file: ~www/.emacs")

(require 'cl)

(setq prefs-maximal-syntax-highlighting-p t)
(setq prefs-advanced-user-p t)

(setq *prefix* "~www/dlisp/")

(defun d-emergency-set-load-path ()
  (assert (boundp '*prefix*))
  (assert *prefix*)
  (setq load-path (cons *prefix* load-path))
  (message "** file: .emacs (car load-path)=%s" (car load-path)))

(d-emergency-set-load-path)

(progn
  (require 'early-bindings)
  (setenv "IS_DAVINS_COMPUTER" "t")
  (d-beeps "Top of ~www/.emacs")
  ;;(require 'd-start)
  )

(d-beeps "Mid of ~www/.emacs")

(require 'd-make-faces)
(d-recenter)
(set-face-background 'default "#eee")
;;(set-face-background 'default "#888")
  
(progn
  (setq max-lisp-eval-depth 6000)
  (setq max-specpdl-size    2600)
  )

(d-emergency-set-load-path)

(safe-require 'tes-mode)
(safe-require 'd-auto-mode-alist)
(safe-require 'd-flm)
(safe-require 'd-key-nav)
(safe-require 'd-key-find)
(safe-require 'd-splat-me)
;;(safe-require 'd-shift-tab) ;; includes d-comp, d-time
;;(safe-require 'd-comp)
(safe-require 'd-keys)
(safe-require 'd-meal-timer)
(safe-require 'd-trashcan)
(safe-require 'd-hippie)
(safe-require 'd-groups) ;; includes d-electric.el
(safe-require 'd-readonly)
;;(safe-require 'd-speedbar) doesn't work...
(safe-require 'd-albums-database)
(safe-require 'd-meta-y)
(safe-require 'jtw-mode)

;; stolen from jtw-build-java.el
(defun warn--are-we-editing-p (filename)
  (setq filename (expand-file-name filename))
  (let ((ptr    (buffer-list))
        (found nil))
    (while (and ptr (not found))
      (if (and os-type-mswindows-p
               (buffer-file-name (car ptr))
               (string=-ignore-case (buffer-file-name (car ptr)) filename))
          (setq found t)
        (if (string= (buffer-file-name (car ptr)) filename)
            (setq found t)))
      (setq ptr (cdr ptr)))
    found)
  )

(defun eb ()
  (interactive)
  (eval-buffer))

(setq tab-width 3)

(defun eb-doit ()
  (interactive)
  (progn
    ;;(setq str (read-from-minibuffer "Enter code to execute: "))
    (shell-command "cd ~/dlisp && cp -puv *.el ~/s/dlisp")
    (load-file "~/preprocessors/dlisp/jtw-build-class-db.el")
    (doit)
    (setq cur-buf (current-buffer))
    (switch-to-buffer cur-buf)
    ;;(setq eval (read-str str))
    ;;(setq e2   (eval eval)))
    )
  )

(defadvice save-buffer (around d-speedbar activate)
  (setq pwd (getenv "PWD"))
  (if (string-match "/preprocessors/dlisp" pwd)
      (kill-buffer)
    ad-do-it)
  )

;; dd-foomatoc mapc ptr-adssd
;; note: touches global variable *cur-buf*
(defadvice debug (around d-debug activate)
  (setq *cur-buf* (current-buffer))
  (switch-to-buffer *cur-buf*)
  ad-do-it)

;; (setq filename (getenv "PWD"))
(defadvice find-file (around d-find-file activate)
  ;;(if (string-match "preprocessors/dlisp" filename)
  ;;(d-error "PATCHED ZYGOTE! Error loading file filename=%s" filename)
  ad-do-it)

(defadvice d-find-file (around d-find-file activate)
  ;;(if (string-match "preprocessors/dlisp" filename)
  ;;    (d-error "PATCHED ZYGOTE! Error loading file filename=%s" filename)
  ad-do-it)

;;(zipzap)

(progn
  (set-default-font "Courier New-18")
  (set-frame-position (selected-frame) 0 0)
  (set-frame-size (caadr (current-frame-configuration)) 80 25)
  )

(defadvice describe-text-properties (around d-dtp activate)
  ad-do-it
  (switch-to-buffer "*Help*")
  (delete-other-windows))

(delete-other-windows)

(d-beeps "Bot of ~www/.emacs")

(custom-set-variables
 ;; custom-set-variables was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 '(blink-cursor-mode t)
 '(column-number-mode t)
 '(show-paren-mode t)
 '(transient-mark-mode nil))
(custom-set-faces
 ;; custom-set-faces was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 )

;;(defadvice kill-buffer (around d-kill-buffer-strobe activate)
;;"Notice that I am to prevent compilation mode emacs errors"
;;(if (and (not (get-buffer "*grep*"))
;;         (not (get-buffer "*compilation*")))
;;    ad-do-it))
;;; BEGIN java-training-wheels stuff
;;; Please do not remove or edit the above line or this will prevent the
;;; preprocessor system from working.
(setq d-target-dir "/home/www/dlisp/")
(setq load-path (append (list (expand-file-name (concat *prefix* "../dlisp")))
   load-path))
;; Set the following variables to nil to turn off Davin's syntax highlighting prefs.
(setq prefs-minimal-syntax-highlighting-p t) ;; keep essential syntax highlighting
(setq prefs-maximal-syntax-highlighting-p t) ;; keep most syntax highlighting
;;(require 'early-bindings)
;;(require 'd-make-faces)
;;(require 'jtw-mode)
;;; END java-training-wheels stuff
;;; Please do not remove or edit the above line or this will prevent the
;;; preprocessor system from working.

