

(global-set-key "\C-o" 'other-window)

(progn
  (global-set-key "\C-x\C-s" 'save-some-buffers)
  (global-set-key "\C-xs"    'save-some-buffers)
  )

(progn
  (global-set-key [S-down-mouse-1] 'ignore)
  (global-set-key [C-down-mouse-2] 'ignore)

  (global-set-key [f1]       'info)
  (global-set-key [f2]       (function
                              (lambda ()
                                (interactive)
                                (save-some-buffers 'NO-QUESTIONS)
                                (message "Saved some buffers...")
                                (sit-for 1)
                                (d-kill-some-buffers 'NO-QUESTIONS))))
  (global-set-key [f3]       (function
                              (lambda ()
                                (interactive)
                                (save-some-buffers 'NO-QUESTIONS))))
  (global-set-key [f4]       'delete-other-windows)
  (global-set-key [f7]       'read-only-mode)
  (global-set-key [f8]       'undo)
  (global-set-key [f12]      'eval-last-sexp)
  (global-set-key [insert]   'electric-buffer-list)
  (progn
    (global-set-key [backspace] 'backward-delete-char)
    (global-set-key [delete]    'delete-char)
    (global-set-key [(control delete)] 'kill-word)
    ;;(global-set-key [(meta    delete)] 'kill-word)
    ;;(global-set-key [(shift   delete)] 'kill-word)
    )

  (defun d-find-file0 (f)
    (interactive "FFind file/folder: ")
    (if (string-match "\\*" f)
        (find-file f 'WILDCARDS)
      (find-file f)))

  (progn
    (global-set-key "\C-d"      'd-find-file0)
    (global-set-key "\C-f"      'd-find-file0)
    (global-set-key "\C-x\C-f"  'd-find-file0)
    (global-set-key "\C-x\C-d"  'd-find-file0)
    (global-set-key "\C-xf"     'd-find-file0)
    (global-set-key "\C-xd"     'd-find-file0)
    (global-set-key [(control tab)] 'other-window)
    ))


(global-set-key [insert] 'electric-buffer-list)

;; -------------------------------------------------

(progn
  (global-set-key [(control right)] 'forward-sexp )
  (global-set-key [(meta right   )] 'forward-sexp )
  (global-set-key [(shift right  )] 'forward-sexp )
  (global-set-key [(control left )] 'backward-sexp)
  (global-set-key [(meta left    )] 'backward-sexp)
  (global-set-key [(shift left   )] 'backward-sexp)
  ;; ------------------------------------------------
  (global-set-key [(control w)] nil)
  (global-set-key "\C-e" 'call-last-kbd-macro)
  (global-set-key "`" 'dabbrev-expand)
  )

(global-set-key "\C-xg"    'goto-line)
(global-set-key "\C-x\C-g" 'goto-line)
(global-set-key "\C-ha"    'apropos) ;; NOTE: better than command-apropos
;;(global-set-key "\C-ha"    'command-apropos)
;;(global-set-key "\C-x\C-q" 'save-buffers-kill-emacs)
(global-unset-key "\C-x\C-q" )
;;(global-set-key "\C-x\C-c" (function (lambda () (interactive) (message "Press \C-x\C-q to quit") (beep) (sleep-for 1))))
(global-unset-key "\C-x\C-c" )

(global-set-key "\C-d" 'd-control-f)
(global-set-key "\C-f" 'd-control-f)

(when prefs-advanced-user-p
  (global-set-key "\e\e" 'eval-expression)
  (global-set-key "`" 'dabbrev-expand)
  ;; for when you miss the real key
  (global-set-key "\e`" 'dabbrev-expand)
  (global-set-key "'" 'd-quote-key)
  (global-set-key "\M-/" 'dabbrev-expand)
  (global-set-key "¿" 'dabbrev-expand)

  (global-set-key "\"" 'self-insert-command)
  ;;(global-set-key "`" 'self-insert-command)

  (defun d-quote-key ()
    (interactive)
    (if (eq (char-after (1- (point))) ?')
        (progn
          (backward-delete-char 1) ;; varsity fixed:
          (insert "`"))
      (if (eq (char-after (1- (point))) ?`)
          (progn
            (backward-delete-char 1) ;; varsity fixed:
            (insert "'"))
        (self-insert-command 1))))

  )

(if (not prefs-windows-bindings-p)
    (global-set-key [(shift   up)] 'd-shift-up))

(global-set-key [(control up)]          'd-shift-up)
(global-set-key [(meta    up)]          'd-shift-up)
(global-set-key [(prior)]               'd-shift-up)

(defun d-shift-up ()
  (interactive)
  (scroll-down 2))

(global-set-key [(control down)]        'd-shift-down)
(global-set-key [(meta    down)]        'd-shift-down)
(if (not prefs-windows-bindings-p)
    (global-set-key [(shift   down)]        'd-shift-down))

(global-set-key [(next)]                'd-shift-down)

(defun d-shift-down ()
  (interactive)
  (scroll-up 2))

(global-set-key [(control next)]        'scroll-up)
(global-set-key [(meta    next)]        'end-of-defun)
(global-set-key [(shift   next)]        'd-forward-page)

(defun d-forward-page ()
  (interactive)
  (if (fboundp 'd-deposit-mark-if-small-movement) (d-deposit-mark-if-small-movement))
  (if (not (re-search-forward "^[ \t]*" nil t))
      (goto-char (point-max)))
  ;;(forward-page)
  (if (= (point) (point-max))
      (recenter (- (window-height) 4))
    (recenter (/ (window-height) 6))))

(global-set-key [(control prior)]       'scroll-down)
(global-set-key [(meta    prior)]       'beginning-of-defun)
(global-set-key [(shift   prior)]       'd-backward-page)

(defun d-backward-page ()
  (interactive)
  (beginning-of-line)
  (if (not (re-search-backward "^[ \t]*" nil t))
      (goto-char (point-min)))
  (skip-chars-forward " \t")
  (skip-chars-forward "")
  (if (fboundp 'd-deposit-mark-if-small-movement) (d-deposit-mark-if-small-movement))
  ;;(backward-page)
  (recenter (/ (window-height) 6)))

(progn
  (global-set-key [(control meta prior)]  'd-backward-page)
  (global-set-key [(control meta next)]   'd-forward-page))

(defun d-control-prior ()
  (interactive)
  (d-scroll-up (- (window-height) 2)))

(defun d-control-next ()
  (interactive)
  (d-scroll-down (- (window-height) 2)))

(defun d-scroll-up (amount)
  "Used by d-control-meta-prior"
  (scroll-down amount)
  (forward-line (- amount))
  (move-to-window-line (/ (window-height) 2)))

(defun d-scroll-down (amount)
  "Used by d-control-meta-next"
  (if (/= (point) (point-max))
      (progn
        (scroll-up amount)
        (forward-line amount)))
  (move-to-window-line (/ (window-height) 2)))

(progn
  (global-set-key [(control home)]      'beginning-of-buffer)
  (global-set-key [(control end)]       'end-of-buffer)
  (global-set-key [(meta home)]         'beginning-of-buffer)
  (global-set-key [(meta end)]          'end-of-buffer)
  (global-set-key [(shift home)]        'beginning-of-buffer)
  (global-set-key [(shift end)]         'end-of-buffer)
  )

(global-set-key [(control right)]       'forward-sexp)
(global-set-key [(meta    right)]       'forward-sexp)
(global-set-key [(shift   right)]       'forward-sexp)
(global-set-key [(control meta right)]  'forward-sexp)

(global-set-key [(control left)]        'backward-sexp)
(global-set-key [(meta    left)]        'backward-sexp)
(global-set-key [(shift   left)]        'backward-sexp)
(global-set-key [(control meta left)]   'backward-sexp)

(global-set-key [(control backspace)]   'backward-kill-word)
(global-set-key [(meta    backspace)]   'backward-kill-word)
(global-set-key [(shift   backspace)]   'backward-kill-word)

(global-set-key [(control delete)]      'kill-word)
(global-set-key [(meta    delete)]      'kill-word)
(global-set-key [(shift   delete)]      'kill-word)

(if prefs-advanced-user-p
    (global-set-key [insert] 'electric-buffer-list)
  )

(global-set-key [(control tab)]         'other-window)
(global-set-key [(shift   tab)]         'other-window)

(global-set-key [(control ?0)]          'delete-window)
(global-set-key [(control ?1)]          'delete-other-windows)
(global-set-key [(control ?@)]          'split-window-vertically) ;; NOTE: Only applicable to Dos Emacs
(global-set-key [(control ?2)]          'split-window-vertically)
(global-set-key [(control ?3)]          'split-window-horizontally)

(progn
  (global-set-key [(shift ? )] 'd-shift-space)
  (global-set-key [(s ?\s- )]  'd-s-space)

  (defun d-shift-space ()
    (interactive)
    (message "pop-mark")
    (pop-mark)
    (recenter)
    )

  (defun d-s-space ()
    (interactive)
    (message "push-mark")
    (push-mark)
    (recenter)
    )
  )

(when prefs-advanced-user-p
  (defalias   'dtp 'describe-text-properties)
  ;;(defalias 'lta 'list-text-properties-at)  ;; version 21.3
  (defalias   'lta 'describe-text-properties) ;; version 22.1
  (defalias   'elm 'emacs-lisp-mode)
  (defalias   'flm 'font-lock-mode)
  (defalias   'qrr 'query-replace-regexp)

  ;;(defalias   'eb  'eval-buffer)
  (defalias   'hff 'hexl-find-file)
  )

(defalias 'buffer-substring-properties 'buffer-substring)
(defalias 'buffer-substring-properties 'd-buffer-substring)
