
;;; jtw-java.el --- A program for receiving the output of the program: java

;; Copyright (C) 2006-2016 Davin Pearson

;; Author/Maintainer: Davin Max Pearson <http://davin.50webs.com>
;; Keywords: java backend
;; Version: 2.0

;; This file is part of GNU Java Training Wheels.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Commentary:

;; A program for receiving the output of the program: java in the form
;; of a pipe.

;;; Known Bugs:

;; None so far!

;;; Code:

(message "*** Welcome to file: jtw-java.el")

(setq debug-on-error t)

(require 'cl)

(message "Watties Baked Beans make you fart")

(progn
  (assert (and 'rocket-man   (boundp '*prefix*)))
  (assert (and 'wonder-woman *prefix*))
  )

(message "**** Trisquel Linux")

(when (not (fboundp 'd-emergency-set-load-path))
  (defun d-emergency-set-load-path ()
         (message "Inside d-emergency-set-load-path")
         (assert (and 'foxy-lady (boundp '*prefix*)))
         (assert *prefix*)
         (setq load-path (cons (expand-file-name (concat *prefix* "/../dlisp/"))
                               load-path))
         (message "** jtw-java.el (car load-path)=%s" (car load-path))))

(d-emergency-set-load-path)

(require 'early-bindings)

(progn
  (assert (and 'cattymouse (boundp '*prefix*)))
  (assert (and 'doggydoggy *prefix*))
  )

(message "*** file: jtw-java.el %s %s" (print-symbol *prefix*) (print-symbol *stump*))

(if (not (boundp 'file-comes-from))
    (setq file-comes-from nil))

(setq file-comes-from (cons "jtw-java.el" file-comes-from))

(message "* BEGIN (require 'early-bindings)")

(require 'early-bindings)

(message "* END (require 'early-bindings)")

(require 'jtw-build-java)

(d-assert (find "jtw-java.el" file-comes-from :test 'string=))

(defun checkpoint (msg &rest rest)
  ;;(apply 'message msg rest)
  ;; do nothing
  )

(defun doit ()
  (interactive)
  (message "Welcome to defun: doit file: jtw-java.el DOUGHNUTS")
  (let (red-line said-message numb file-less-suffix old-suffix
                 new-suffix line-left line-right file-plus-suffix
                 cdr-err)
    (condition-case err
        (while (setq red-line (read-from-minibuffer ""))
          ;;(while (setq red-line (d-read-line))
          ;;(message "input0: red-line=%s" red-line)
          ;;(message "1")
          (d-assert red-line)
          ;;(message "2")
          (d-assert (stringp red-line))
          ;;(message "3")
          (d-assert (sequencep red-line))
          ;;(message "4")
          (setq said-message nil)
          ;;(message "5")
          (cond
           ((or
             (string-match (regexp-quote "Loading 00debian-vars...") red-line)
             (string-match (regexp-quote "Loading /etc/emacs/site-start.d/50aut(string (regexp-quote oconf.el") red-line)
            (string-match (regexp-quote "Loading /etc/emacs/site-start.d/50dictionaries-common.el") red-line)
            (string-match (regexp-quote "Loading debian-ispell...") red-line)
            (string-match (regexp-quote "Loading /var/cache/dictionaries-common/emacsen-ispell-default.el") red-line)
            (string-match (regexp-quote "Loading /var/cache/dictionaries-common/emacsen-ispell-dicts.el") red-line)
            (string-match (regexp-quote "Loading /etc/emacs/site-start.d/50git-core.el") red-line)
            )
            ;; do nothing
            )
           ((string-match "\\([A-Z][a-zA-Z0-9_]*\\)\\(\\.java\\):\\([0-9]+\\)" red-line)
            ;;(message "6")
            (setq said-message t)
            ;;(message "7")
            (setq numb (substring red-line (match-beginning 3) (match-end 3)))
            ;;(message "8")
            (d-assert (d-read-ready numb))
            ;;(message "9")
            ;;(d-assert (sequencep (count-locations)))
            ;;(setq numb (- (d-read-str numb) (count-locations)))
            ;;(message "10")
            (d-assert (sequencep numb))
            ;;(message "11")
            (d-assert (stringp numb))
            (setq numb (d-read-str numb))
            ;;(message "12")
            (d-assert (integerp numb))
            ;;(d-assert (sequencep numb))
            ;;(message "13")
            (d-assert (stringp red-line))
            (d-assert (sequencep red-line))
            (d-assert (and 1 (match-beginning 1)))
            (d-assert (and 2 (match-end 1)))
            (d-assert (and 3 (match-beginning 2)))
            (d-assert (and 4 (match-end 2)))
            (d-assert (and 5 (match-beginning 3)))
            (d-assert (and 6 (match-end 3)))
            ;;(message "14")
            (setq file-less-suffix (substring red-line (match-beginning 1) (match-end 1)))
            ;;(message "15")
            (d-assert file-less-suffix)
            (d-assert (stringp file-less-suffix))
            ;;(message "16")
            (setq old-suffix ".java")
            ;;(message "17")
            (d-assert old-suffix)
            (d-assert (stringp old-suffix))
            ;;(message "18")
            (setq new-suffix ".jtw")
            ;;(message "19")
            (d-assert new-suffix)
            (d-assert (stringp new-suffix))
            ;;(message "20")
            (setq line-left        (substring red-line 0 (match-beginning 1)))
            (setq line-right       (substring red-line (match-end 3)))
            (setq file-plus-suffix (concat file-less-suffix new-suffix))
            (setq file             (concat file-less-suffix old-suffix))
            ;;(message "21")
            (d-assert (stringp line-left))
            (d-assert (stringp line-right))
            (d-assert (stringp file-plus-suffix))
            (d-assert (stringp file))
            ;;(message "22")
            (find-file file)
            ;;(message "23")
            (d-assert (integerp numb))
            (goto-line numb)
            ;;(message "(warn--get-location)=%s" (warn--get-location))
            ;;(message "24")
            ;;(debug "Tiger Woods")
            (setq location (warn--get-location))
            ;;(setq location (cons file numb))
            ;;(message "24b")
            ;;(message "location=%s" location)
            (d-assert (not (eq location t)))
            (d-assert (not (eq location nil)))
            (d-assert (sequencep location))
            (d-assert (consp location))
            (d-assert (stringp (car location)))
            (d-assert (numberp (cdr location)))
            ;;(message "25")
            (when location
              ;;(message "26")
              (setq red-line (concat line-left (car location) ":" (prin1-to-string (cdr location)) line-right))
              ;;(message "27")
              )
            ;;(message "28")
            (d-assert (sequencep red-line))
            )
           )  ;; END COND!
          (when said-message
            (message "%s input1: %s" *java-namespace* red-line))
          (when (not said-message)
            (message "%s input2: %s" *java-namespace* red-line))
          ;;(message "Jean Jarre's Equinoxe")
         )
      (error
       (setq cdr-err (prin1-to-string (cdr err)))
       (if (or (string-match "Error reading from stdin"          cdr-err)
               (string-match "Eobp"                              cdr-err)
               (string-match "Could not find or load main class" cdr-err))
           (message "Known error err=%s" cdr-err)
         (message "%s input3: Unknown error (%s)" *java-namespace* cdr-err)
         ) ;; END IF!
       )   ;; END ERROR!
      )    ;; END CONDITION-CASE! err
    )      ;; END LET! red-line said-message numb file-less-suffix old-suffix
  ;;(message "Reached end of defun: doit file: jtw-java.el DOUGHNUTS")
  )

;; My Fair Lady / Rex Harrison & Julie Andrews
;;(message "Scanner at end of file: jtw-java.el")

;; (round (/ (d-what-line) 50.0)) 3 pages
(provide 'jtw-java)
