

;; (setq ch ?b)
;; (setq ch ?1)
(defun d-char-to-upper-case-char (ch)
  (d-assert ch)
  ;;(debug "Foomatic")
  (cond
   ((and (>= ch ?a) (<= ch ?z))
    (setq ch (+ (- ch ?a) 65)))
   ((and (>= ch ?A) (<= ch ?Z))
    (setq ch (+ (- ch ?A) 97)))
   ((and (>= ch ?0) (<= ch ?9))
    (setq ch (+ (- ch ?0) 48)))
   (t
    (d-error "Error in d-to-upper-case function"))))

;; (setq ch ?b)
;; (setq ch ?3)
(defun d-char-to-int (ch)
  (d-assert ch)
  (setq ch (d-char-to-upper-case-char ch))
  (cond
   ((and (>= ch ?A) (<= ch ?Z))
    (setq ch (+ (- ch ?A) 10)))
   ((and (>= ch ?0) (<= ch ?9))
    (setq ch (- ch ?0)))
   (t
    (d-error "Error in d-char-to-int function"))))

;;;
(defun d-int-invert (i)
  (setq i (- 15 i)))

;; (int-to-char (setq i 7))
(defun d-int-to-char (i)
  (d-assert i)
  (cond
   ((>= i 10)
    (+ (- i 10) ?a))
   ((< i 10)
    (+ i ?0))
   (t
    (d-error "Error in d-int-to-char function"))))

;; (setq i 15)
(defun d-int-to-char (i)
  (let (ch)
    (if (or (< i 0) (> i 15))
        (d-error "d-int-to-char: error: Value out of bounds")
      (if (< i 10)
          (setq ch (+ (- i 10) ?a))
        (if (< i 16)
            (setq ch (+ (- i 10) ?0)))))))

;; (d-invert 13)
(defun d-invert (i)
  (- 15 i))

;; (d-rgb-string-to-list (rgb-split-string (setq rgb-str "#fe0")))
;; (d-rgb-string-to-list (setq rgb-str "#ffee00"))
(defun d-rgb-string-to-list (rgb-str)
  (cond
   ((= (length rgb-str) 4)
    (let (r g b)
      (setq r (aref (substring rgb-str 1 2) 0))
      (setq g (aref (substring rgb-str 2 3) 0))
      (setq b (aref (substring rgb-str 3 4) 0))
      (setq r (d-char-to-int r))
      (setq g (d-char-to-int g))
      (setq b (d-char-to-int b))
      (list r g b)))
   ((= (length rgb-str) 7)
    (let (r1 r2 g1 g2 b1 b2)
      (setq r1 (aref (substring rgb-str 1 2) 0))
      (setq r2 (aref (substring rgb-str 2 3) 0))
      (setq g1 (aref (substring rgb-str 3 4) 0))
      (setq g2 (aref (substring rgb-str 4 5) 0))
      (setq b1 (aref (substring rgb-str 5 6) 0))
      (setq b2 (aref (substring rgb-str 6 7) 0))
      (setq r1 (d-char-to-int r1))
      (setq r2 (d-char-to-int r2))
      (setq g1 (d-char-to-int g1))
      (setq g2 (d-char-to-int g2))
      (setq b1 (d-char-to-int b1))
      (setq b2 (d-char-to-int b2))
      (list r1 r2 g1 g2 b1 b2)))
   (t
    (error "Wrong string length not 4 or 7"))))

;; (d-rgb-list-to-string (setq rgb-list '(15 0 8)))
;; (d-rgb-list-to-string (setq rgb-list '(15 15 0 0 8 8)))
(defun d-rgb-list-to-string (rgb-list)
  (setq len (length rgb-list))
  (cond
   ((= len 3)
    (concat "#"
            (format "%1X" (nth 0 rgb-list))
            (format "%1X" (nth 1 rgb-list))
            (format "%1X" (nth 2 rgb-list))))

   ((= len 6)
    (concat "#"
            (format "%1X" (nth 0 rgb-list))
            (format "%1X" (nth 1 rgb-list))
            (format "%1X" (nth 2 rgb-list))
            (format "%1X" (nth 3 rgb-list))
            (format "%1X" (nth 4 rgb-list))
            (format "%1X" (nth 5 rgb-list))))
   (t
    (error "Should never happen"))))

;; (rgb-inverted (setq str "#f00"))
(defun rgb-inverted (str)
  (progn
    (setq list (d-rgb-string-to-list str))
    (setq list (mapcar 'd-invert list))
    (setq str  (d-rgb-list-to-string list))
    ))

(progn
  (setq list (d-rgb-string-to-list "#f8f"))
  (mapcar 'd-invert list)
  (setq str  (d-rgb-list-to-string list))
  )

(provide 'rgb-inverted)

;; New namespace: dmp::foomatic
